//--------LICENSE_START--------
//
// Copyright (C) 2020,2021,2022 Institut de Robòtica i Informàtica Industrial, CSIC-UPC.
// Authors: Joan Solà Ortega (jsola@iri.upc.edu)
// All rights reserved.
//
// This file is part of WOLF
// WOLF is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//--------LICENSE_END--------
#include "bodydynamics/sensor/sensor_force_torque.h"

#include "core/state_block/state_block.h"
#include "core/state_block/state_quaternion.h"

namespace wolf {

SensorForceTorque::SensorForceTorque(const Eigen::VectorXd& _extrinsics, ParamsSensorForceTorquePtr _params) :
                SensorBase("SensorForceTorque",
                           nullptr,
                           nullptr,
                           nullptr,
                           (Eigen::Matrix<double, 12, 1>() << _params->std_f,_params->std_f,_params->std_f,
                                                              _params->std_f,_params->std_f,_params->std_f,
                                                              _params->std_tau,_params->std_tau,_params->std_tau,
                                                              _params->std_tau,_params->std_tau,_params->std_tau).finished(),
                           false,
                           false,
                           true),
                mass_(_params->mass),
                std_f_(_params->std_f),
                std_tau_(_params->std_tau)
{
    assert(_extrinsics.size() == 0 && "Wrong extrinsics vector size! Should be 0");
}


} // namespace wolf

// Register in the FactorySensor
#include "core/sensor/factory_sensor.h"
namespace wolf {
WOLF_REGISTER_SENSOR(SensorForceTorque)
} // namespace wolf
